Epic # 55070 (Accepted): Workpackages
Epic # 54260 (Accepted): WP: FAL Missing Issues / Features / API
Story # 54267 (Resolved): As an Editor I want to use a FAL withouth bugs

Status: Resolved Priority: Should have
Author: Bernhard Kraft Category: File Abstraction Layer (FAL)
Created: 2013-08-29 Assigned To: Steffen Ritter
Updated: 2014-12-15 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: medium
Sprint Focus:
Subject: Unreadable directories cause exceptions
Description

If there is an unreadable file in the fileadmin directory the tree and listing frame of fileadmin throw execptions which make the fileadmin
unusable.

reproducing the error:

mkdir -p fileadmin/testDirectory/someDirectory
chown root:root fileadmin/testDirectory/someDirectory
chmod 600 fileadmin/testDirectory/someDirectory

Browse to "testDirectory" and the issues begin ...

Normally all directoreis in "fileadmin" should be readable but in the case of a network mounted directory (Windows share, SMB/CIFS,
NFS, cloud storage, etc.) it could be that parts of the fileadmin directory are unreadable and that this can not get changed by the
webadmin.

I am working on a patch.

Related issues:
related to Core - Bug # 59568: filelist: No context-menu for folders Resolved 2014-06-13
duplicated by Core - Bug # 53854: Exception if a directory in storage isn't r... Closed 2013-11-22

Associated revisions
Revision 017242ff - 2014-01-30 19:36 - Steffen Ritter

[BUGFIX] Exception if directories are not readable

If a user has listing rights on a folder which contains
folders he does not have access to the user currently
will end up with Exceptions in folder trees, file lists
as well as element browsers.

Before FAL these folders just have been shown "locked".

This change introduces an "InaccessibleFolder" object
which will be created by the storage if a Folder is

2015-08-04 1/4



requested which exists but there is no read access while
the user is allowed to list the contents of the parent
folder.

In addition the components have been adapted to use this
new information for a graceful behaviour.

WIP: Did not adapt the tests yet, since I need to do some
urgent customer work. Feel free to go on with that.

Resolves: #51512, #53854
Releases: 6.2
Change-Id: If5c234fe66d1930e4cc0cb16279d2f77874d82db
Reviewed-on: https://review.typo3.org/26905
Tested-by: Ingo Schmitt
Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring
Reviewed-by: Ingo Schmitt
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History
#1 - 2013-08-29 13:57 - Philipp Gampe
- Category changed from Backend User Interface to File Abstraction Layer (FAL)
- Status changed from New to Accepted
- Assigned To set to Bernhard Kraft
- Complexity set to medium

#2 - 2013-08-29 14:29 - Bernhard Kraft
- File patch_51512.diff added

#3 - 2013-08-29 14:33 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23460

#4 - 2013-08-29 14:34 - Bernhard Kraft
- Status changed from Under Review to Accepted

https://review.typo3.org/#/c/23460/

#5 - 2013-08-30 11:08 - Bernhard Kraft

The question is:

Should the drivers of a FAL storage throw execptions in the case of an error and those exceptions should get handled by the Repository/Storage.
Or should a driver never throw an exception but catch them on the public methods available to the Storage and simply return NULL value results or
empty arrays in such a case.

#6 - 2013-09-13 18:45 - Andreas Wolf
- Is Regression set to No

Catching exceptions is the responsibility of the UI/control logic, because it knows best how to deal with them - display a message, discard them or just
let the whole operation fail. Driver exceptions could be wrapped by the Storage, to have unified exceptions, but that's not strictly necessary if we limit
the types of exceptions that drivers might throw for certain operations.

#7 - 2013-11-30 18:29 - Steffen Ritter
- Assigned To changed from Bernhard Kraft to Steffen Ritter

#8 - 2013-12-07 15:59 - Steffen Ritter
- Parent task set to #54267

#9 - 2014-01-21 11:08 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26905

#10 - 2014-01-21 11:08 - Steffen Ritter
- % Done changed from 0 to 50

#11 - 2014-01-21 12:56 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26905

#12 - 2014-01-30 12:22 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26905

#13 - 2014-01-30 18:18 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26905

#14 - 2014-01-30 20:30 - Steffen Ritter
- Status changed from Under Review to Resolved
- % Done changed from 50 to 100
Applied in changeset commit:017242ff31178adb38812179637923ce94518043.

#15 - 2014-12-15 20:40 - Georg Ringer

works now, can't reproduce in master.

Files
patch_51512.diff 1019 Bytes 2013-08-29 Bernhard Kraft
